`timescale 1 ns / 1 ps
`define NULL 0 

module keylog_tb;

reg clk;
reg rst_n;
reg dp;
reg dm;

wire tx;

reg clk_usb;

initial
begin
	rst_n = 0;
	clk = 0;
	clk_usb = 0;
	#100 rst_n = 1;
end

always
begin
	#5 clk_usb = 1;
	#5 clk_usb = ~clk_usb;
end

always
begin
	#21 clk = 1;
	#21 clk = ~clk;
end

integer dp_next, dm_next;

integer data_file; // file handler
integer scan_file;
initial begin
	data_file = $fopen("./logicdata.tsv", "r");
	scan_file = $fscanf(data_file, "%d\t%d\t%d\n", sample_next, dm_next, dp_next); 
	if (data_file == `NULL) begin
		$display("data file not exist, exit...");
		$finish;
	end
end

integer clk_cnt = 0;
integer sample_next = 0;
always @(posedge clk_usb) begin
	if (sample_next == clk_cnt) begin
		dp = dp_next;
		dm = dm_next;
		scan_file = $fscanf(data_file, "%d\t%d\t%d\n", sample_next, dm_next, dp_next); 
		if ($feof(data_file)) begin
			$display("end of data file, exit...");
			$finish;
		end
	end
	clk_cnt = clk_cnt + 1;
end


keylog m(
	.clk(clk),
	.rst_n(rst_n),
	.dm(dm),
	.dp(dp),
	.tx(tx)
);

initial begin
	$dumpfile("keylog.vcd");
	$dumpvars();
end

endmodule
